package be.iminds.ilabt.jfed.experimenter_gui.config;

import be.iminds.ilabt.jfed.util.common.GeniUrn;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;

import java.util.Objects;

public class TestbedSiteInfo {
    private final GeniUrn urn;
    private final String hrn;
    private final IntegerProperty availableComponents;
    private final IntegerProperty totalComponents;

    public TestbedSiteInfo(GeniUrn urn, String hrn) {
        this.urn = urn;
        this.hrn = hrn;
        this.availableComponents = new SimpleIntegerProperty(-1);
        this.totalComponents = new SimpleIntegerProperty(-1);
    }

    public TestbedSiteInfo(GeniUrn urn, String hrn, int availableComponents, int totalComponents) {
        this.urn = urn;
        this.hrn = hrn;
        this.availableComponents = new SimpleIntegerProperty(availableComponents);
        this.totalComponents = new SimpleIntegerProperty(totalComponents);
    }

    public GeniUrn getUrn() {
        return urn;
    }

    public String getHrn() {
        return hrn;
    }

    public int getAvailableComponents() {
        return availableComponents.get();
    }

    public IntegerProperty availableComponentsProperty() {
        return availableComponents;
    }

    public int getTotalComponents() {
        return totalComponents.get();
    }

    public IntegerProperty totalComponentsProperty() {
        return totalComponents;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        TestbedSiteInfo that = (TestbedSiteInfo) o;
        return Objects.equals(urn, that.urn);
    }

    @Override
    public int hashCode() {
        return Objects.hash(urn);
    }
}
