package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.log.ResultListener;
import be.iminds.ilabt.jfed.lowlevel.api.AbstractFederationApi;
import be.iminds.ilabt.jfed.util.common.GeniUrn;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.time.Instant;
import java.util.Collection;

/**
 * User: twalcari
 * Date: 6/18/2015
 * Time: 13:26
 */
public interface SliceAuthorityTaskFactory {
    RegisterOrUpdateSliversTask registerSlivers(Slice slice, Server auth, Collection<GeniUrn> sliverUrns,
                                                Instant sliverExpirationDate, Task extraTaskToDependOn, ResultListener... extraResultListeners);

    RegisterOrUpdateSliversTask updateSlivers(Slice slice, Server auth, Collection<GeniUrn> sliverUrns,
                                              Instant sliverExpirationDate, Task extraTaskToDependOn, ResultListener... extraResultListeners);

    UnregisterSliversTask unregisterSlivers(@Nonnull Slice slice, @Nonnull Server auth,
                                            @Nonnull Collection<GeniUrn> sliversToUnregister, Task extraDependsOnTask,
                                            ResultListener... resultListeners);

    RegisterSliceRspecTask registerSliceRspec(@Nonnull AbstractFederationApi.SliceRspecType type, @Nonnull Slice slice, @Nullable Server auth,
                                              @Nonnull String rspec, @Nonnull Instant sliceProvisionDate,
                                              @Nullable Task extraTaskToDependOn, ResultListener... extraResultListeners);
}
